Debian Bug report logs - #465783
perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages

version graph

Package: perl; Maintainer for perl is Niko Tyni <ntyni@debian.org>; Source for perl is src:perl.

Reported by: Niko Tyni <ntyni@debian.org>

Date: Thu, 14 Feb 2008 19:33:01 UTC

Severity: serious

Tags: patch

Found in version perl/5.10.0-3

Done: Marc 'HE' Brockschmidt <he@ftwca.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-perl@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
New Bug report received and forwarded. Copy sent to debian-perl@lists.debian.org, Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: submit@bugs.debian.org
Subject: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Thu, 14 Feb 2008 21:13:10 +0200
[Message part 1 (text/plain, inline)]
Package: perl
Version: 5.10.0-3
Severity: serious
Tags: patch
X-Debbugs-Cc: debian-perl@lists.debian.org

Given the recent announcement of the Lenny release schedule [1] with a
"very soft freeze" in a few weeks from now, I propose that the infamous
"installs an empty /usr/{share,lib}/perl5 directory" bug is reintroduced
until Lenny is released.

For the sake of completeness, the story is that a bug in Extutils::Install
used to create empty /usr/lib/perl5 or /usr/share/perl5 directories,
and dh-make-perl templates included for a long time a debian/rules line
that unconditionally rmdir'd it.

This bug was fixed upstream in ExtUtils::Install 1.41_04, and the fix
is included in Perl 5.10.0. As a result, hundreds of Debian packages
fail to build with perl 5.10.0-3 from experimental because they try to
remove a non-existent directory.

I run a few greps on debian/rules of the source packages of all the
binary packages matching '-perl' in unstable. Results: at least 398
arch:all and 38 arch:any packages apparently do an unconditional rmdir
for the empty directory.

I have tried my best to avoid false positives, but I'd be delighted if
there's a mistake here.

The arch:any packages are particularly important because they will
be uninstallable when perl 5.10 hits unstable and must be rebuilt
first. Most of the bugs for the 38 packages have already been filed,
using the 'debian-perl@lists.debian.org' / 'perl-5.10-transition' usertag
[2]. The arch:all packages will "only" start to FTBFS, creating 400 new
RC bugs in one go.

Out of the 436 packages I found, 196 are maintained by the pkg-perl group.
These are already listed on the pkg-perl website [3]. I'm attaching the
dd-list output for the remaining 240 packages.

Given these depressing numbers, I think we should postpone breaking
these packages until after Lenny. The attached patch reverts this
particular change in Extutils::Install; I have only done some cursory
testing but it seems to do the right thing.

This doesn't mean that the packages are OK, of course. Maybe a lintian
check for the buggy rmdir invocations would be a good start at fixing
them...

[1] http://lists.debian.org/debian-devel-announce/2008/02/msg00002.html
[2] http://bugs.debian.org/cgi-bin/pkgreport.cgi?users=debian-perl@lists.debian.org
[3] http://pkg-perl.alioth.debian.org/perl5.10-FTBFS.txt

Cheers,
-- 
Niko Tyni   ntyni@debian.org
[extutils-empty-directory.patch (text/x-diff, attachment)]
[dd-list.no-pkg-perl (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #10 received at 465783@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Niko Tyni <ntyni@debian.org>, 465783@bugs.debian.org
Cc: lucas@debian.org
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Fri, 15 Feb 2008 09:39:42 +0100
On Thu, 14 Feb 2008, Niko Tyni wrote:
> I run a few greps on debian/rules of the source packages of all the
> binary packages matching '-perl' in unstable. Results: at least 398
> arch:all and 38 arch:any packages apparently do an unconditional rmdir
> for the empty directory.

I tend to disagree. The number are big but the fix is easy. I'd suggest
to work with Lucas to do a full rebuild with perl 5.10 and submit those
400 bugs right now with severity important. Also usertag them to be able
to follow the evolution.

Then make an announce on d-d-a with a list of maintainers that have to
update their packages. Also inform that an NMU campaign may be done on
those bugs (even before they become RC).

In fact, you can already post the dd-list you prepared together with
detailed explanations on the nature of the problem on d-d-a.

We need to communicate so that people fix the bugs... otherwise nothing
will happen. Reverting the behaviour can still be done if we have too many
of those bugs open once perl 5.10 reaches unstable. If not, the bugs will
be upgraded to serious at that time and that will make sure that the
remaining bugs are fixed.

Cheers,
-- 
Raphaël Hertzog

Le best-seller français mis à jour pour Debian Etch :
http://www.ouaza.com/livre/admin-debian/




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #15 received at 465783@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 465783@bugs.debian.org
Cc: lucas@lucas-nussbaum.net
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Mon, 18 Feb 2008 22:20:50 +0200
On Fri, Feb 15, 2008 at 09:39:42AM +0100, Raphael Hertzog wrote:
> On Thu, 14 Feb 2008, Niko Tyni wrote:
> > I run a few greps on debian/rules of the source packages of all the
> > binary packages matching '-perl' in unstable. Results: at least 398
> > arch:all and 38 arch:any packages apparently do an unconditional rmdir
> > for the empty directory.
> 
> I tend to disagree. The number are big but the fix is easy. I'd suggest
> to work with Lucas to do a full rebuild with perl 5.10 and submit those
> 400 bugs right now with severity important. Also usertag them to be able
> to follow the evolution.
> 
> Then make an announce on d-d-a with a list of maintainers that have to
> update their packages. Also inform that an NMU campaign may be done on
> those bugs (even before they become RC).
> 
> In fact, you can already post the dd-list you prepared together with
> detailed explanations on the nature of the problem on d-d-a.

Done, although I settled for debian-devel (and debian-perl as a spam
filter ate the X-Debbugs-Cc of this bug) at this point.

Lucas, could you please help with the test rebuilds?

A full archive rebuild with perl 5.10 from experimental
is going to need some bootstrapping, as outlined in
http://wiki.debian.org/Perl5.10Transition .  In particular, the
libxml-parser-perl dependency loop is going to require manual attention.

I think it would make sense to get the uninstallable arch:any packages
rebuilt first with the ExtUtils::Install change reverted to get around
the 'empty rmdir' issue when bootstrapping.

It would of course be also interesting to compare the list packages that
FTBFS with and without the ExtUtils::Install change.

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #20 received at 465783@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Niko Tyni <ntyni@debian.org>
Cc: 465783@bugs.debian.org
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Thu, 21 Feb 2008 22:48:37 +0100
On 18/02/08 at 22:20 +0200, Niko Tyni wrote:
> On Fri, Feb 15, 2008 at 09:39:42AM +0100, Raphael Hertzog wrote:
> > On Thu, 14 Feb 2008, Niko Tyni wrote:
> > > I run a few greps on debian/rules of the source packages of all the
> > > binary packages matching '-perl' in unstable. Results: at least 398
> > > arch:all and 38 arch:any packages apparently do an unconditional rmdir
> > > for the empty directory.
> > 
> > I tend to disagree. The number are big but the fix is easy. I'd suggest
> > to work with Lucas to do a full rebuild with perl 5.10 and submit those
> > 400 bugs right now with severity important. Also usertag them to be able
> > to follow the evolution.
> > 
> > Then make an announce on d-d-a with a list of maintainers that have to
> > update their packages. Also inform that an NMU campaign may be done on
> > those bugs (even before they become RC).
> > 
> > In fact, you can already post the dd-list you prepared together with
> > detailed explanations on the nature of the problem on d-d-a.
> 
> Done, although I settled for debian-devel (and debian-perl as a spam
> filter ate the X-Debbugs-Cc of this bug) at this point.
> 
> Lucas, could you please help with the test rebuilds?

Well, 400 packages isn't really a lot. With a fast computer, they
probably wouldn't take more than a day to build.

> A full archive rebuild with perl 5.10 from experimental
> is going to need some bootstrapping, as outlined in
> http://wiki.debian.org/Perl5.10Transition .  In particular, the
> libxml-parser-perl dependency loop is going to require manual attention.

My process for rebuilds doesn't support bootstrapping: the chroot has to
be the same for all the packages I'm building. If the number of packages
to bootstrap is small, it's probably simpler to just build those
packages manually, and then build all the other packages in a chroot
with those bootstraped packages installed.

> I think it would make sense to get the uninstallable arch:any packages
> rebuilt first with the ExtUtils::Install change reverted to get around
> the 'empty rmdir' issue when bootstrapping.
> 
> It would of course be also interesting to compare the list packages that
> FTBFS with and without the ExtUtils::Install change.

... but I can do two rebuilds, with two different chroots, if needed.

For each rebuild, I would need you to provide debs for i386 for all
packages that differ from their version in unstable. Ideally, I would
just have to dpkg -i *deb ; apt-get -f install, save the chroot, rebuild
the packages.

Also, I would need the list of packages you want me to rebuild.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Brendan O'Dea <bod@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #25 received at 465783@bugs.debian.org (full text, mbox):

From: Brendan O'Dea <bod@debian.org>
To: Raphael Hertzog <hertzog@debian.org>, 465783@bugs.debian.org
Cc: Niko Tyni <ntyni@debian.org>, lucas@debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Sat, 23 Feb 2008 01:09:09 +1100
On Fri, Feb 15, 2008 at 09:39:42AM +0100, Raphael Hertzog wrote:
>On Thu, 14 Feb 2008, Niko Tyni wrote:
>> I run a few greps on debian/rules of the source packages of all the
>> binary packages matching '-perl' in unstable. Results: at least 398
>> arch:all and 38 arch:any packages apparently do an unconditional rmdir
>> for the empty directory.
>
>I tend to disagree. The number are big but the fix is easy. I'd suggest
>to work with Lucas to do a full rebuild with perl 5.10 and submit those
>400 bugs right now with severity important. Also usertag them to be able
>to follow the evolution.

I'm keen to get 5.10 into Lenny, since the length of our stable release
cycles otherwise means that we'll be stuck with 5.8 for quite a while.

My initial thought was to set up a staging area, although was told that
with the binNMU mechanism it should no longer be necessary...  This
issue with rmdir however would appear to have torpedoed that plan.

Given the mechanical nature of the fix required, I am still inclined to
uploading to unstable before the soft freeze in a week or so.  Remember,
it's called "unstable" for a reason, people.

--bod

#!/usr/bin/perl -lp
if (m!^\s+(@\s*)?rmdir(\s+(--parents|--ignore-fail-on-non-empty|-p))*((\s+\S+/(lib|share)/perl5)+)\s*$!)
{
  $_ = join "\n",
       map "\t[ ! -d $_ ] || rmdir --ignore-fail-on-non-empty --parents --verbose $_",
       split ' ', $4;
}





Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #30 received at 465783@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>
Cc: 465783@bugs.debian.org
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Fri, 22 Feb 2008 21:55:16 +0200
On Thu, Feb 21, 2008 at 10:48:37PM +0100, Lucas Nussbaum wrote:
> On 18/02/08 at 22:20 +0200, Niko Tyni wrote:

> > Lucas, could you please help with the test rebuilds?
> 
> Well, 400 packages isn't really a lot. With a fast computer, they
> probably wouldn't take more than a day to build.

> For each rebuild, I would need you to provide debs for i386 for all
> packages that differ from their version in unstable. Ideally, I would
> just have to dpkg -i *deb ; apt-get -f install, save the chroot, rebuild
> the packages.

Hm, never mind. The bootstrapping phase is probably most of the work,
as more than 300 uninstallable arch:any packages need binNMUs and some
depend on each other. 

I'm now mostly done with that, and I'll try tackle the arch:all *-perl
packages too this weekend. This is on amd64, so I can't even provide
the i386 .debs :)

Thanks anyway,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #35 received at 465783@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 465783@bugs.debian.org
Cc: debian-perl@lists.debian.org
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Mon, 17 Mar 2008 21:43:36 +0200
[Message part 1 (text/plain, inline)]
On Sat, Feb 23, 2008 at 01:09:09AM +1100, Brendan O'Dea wrote:

> >On Thu, 14 Feb 2008, Niko Tyni wrote:
> >> I run a few greps on debian/rules of the source packages of all the
> >> binary packages matching '-perl' in unstable. Results: at least 398
> >> arch:all and 38 arch:any packages apparently do an unconditional rmdir
> >> for the empty directory.

Update: three weeks after my mass bug filing 70% of the 'arch:all rmdir
failed' (aka. perl-5.10-ftbfs-rmdir on [1]) bugs have been fixed. There
are still 119 of them left, though. Kudos particularly to Gregor and
the other hard-working pkg-perl folks for the almost endless stream of
closed bugs :)

Additionally, there are 13 arch:all packages that fail to build for other
reasons ('perl-5.10-ftbfs' on [1]), mainly due to test suite failures.
Two of them are still using pseudo hashes..

> I'm keen to get 5.10 into Lenny, since the length of our stable release
> cycles otherwise means that we'll be stuck with 5.8 for quite a while.
> 
> My initial thought was to set up a staging area, although was told that
> with the binNMU mechanism it should no longer be necessary...  This
> issue with rmdir however would appear to have torpedoed that plan.

Out of the 310 arch:any packages that need to be binNMU'd, 36 currently
fail to build with Perl 5.10 (most of 'perl-5.10-transition' on [1]).
These take 8 more with them because their build dependencies include
libxml-parser-perl (#458144) or libpadwalker-perl (#463546) from the
first set.

21 of the 36 failures are due to the 'rmdir issue'.

Note that this doesn't take into account 'regular' FTBFS issues on
current sid, I haven't usertagged those.

Anyway, it looks like the binNMU plan is still good, and a patch/NMU
campaign of the relatively few 'perl-5.10-transition' bugs on [1] would
make it even better. Any takers?

> Given the mechanical nature of the fix required, I am still inclined to
> uploading to unstable before the soft freeze in a week or so.  Remember,
> it's called "unstable" for a reason, people.

It's been more than three weeks now. Any news on the schedule?

[1] usertag overview linked from the end of 
    http://wiki.debian.org/Perl5.10Transition

Cheers,
-- 
Niko Tyni   ntyni@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Damyan Ivanov <dmn@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #40 received at 465783@bugs.debian.org (full text, mbox):

From: Damyan Ivanov <dmn@debian.org>
To: 465783@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#465783: perl: ExtUtils::Install upgrade in Perl 5.10 breaks too many packages
Date: Tue, 25 Mar 2008 15:09:52 +0200
[Message part 1 (text/plain, inline)]
-=| Niko Tyni, Mon, Mar 17, 2008 at 09:43:36PM +0200 |=-
> On Sat, Feb 23, 2008 at 01:09:09AM +1100, Brendan O'Dea wrote:
> Update: three weeks after my mass bug filing 70% of the 'arch:all rmdir
> failed' (aka. perl-5.10-ftbfs-rmdir on [1]) bugs have been fixed. There
> are still 119 of them left, though. Kudos particularly to Gregor and
> the other hard-working pkg-perl folks for the almost endless stream of
> closed bugs :)

Full ack here. Gregor did an amazing job, fixing almost all of the
ftbfs-rmdir bugs for pkg-perl packages. And this was not simply running the
packagecheck script that makes the change in debian/rules automatically
(guess who wrote it -- Gregor!). All the packages were also brought to
the current group practices. And I can say that reviewing a package that
Gregor has updated was quite boring -- they were all just fine :)

> Anyway, it looks like the binNMU plan is still good, and a patch/NMU
> campaign of the relatively few 'perl-5.10-transition' bugs on [1] would
> make it even better. Any takers?

There are still 109 ftbfs-rmdir bugs. An NMU campaign can take them off
quite quickly[2]. However, I feel a bit uncomfortable doing NMUs for bugs
of severity 'important' when the bugs are not even associated with a
release goal[0].

    [2] I am thinking about automating the gory details
    [0] http://release.debian.org/lenny/goals.txt

Wouldn't the release team be pissed if the perl5.10 transition is done
without them be aware if it?

> [1] usertag overview linked from the end of 
>     http://wiki.debian.org/Perl5.10Transition

-- 
dam            JabberID: dam@jabber.minus273.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #45 received at 465783@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: 465783@bugs.debian.org, debian-perl@lists.debian.org
Cc: debian-release@lists.debian.org
Subject: perl 5.10 transition, NMUs and release goals
Date: Tue, 25 Mar 2008 15:15:25 +0100
On Tue, 25 Mar 2008, Damyan Ivanov wrote:
> > Anyway, it looks like the binNMU plan is still good, and a patch/NMU
> > campaign of the relatively few 'perl-5.10-transition' bugs on [1] would
> > make it even better. Any takers?
> 
> There are still 109 ftbfs-rmdir bugs. An NMU campaign can take them off
> quite quickly[2]. However, I feel a bit uncomfortable doing NMUs for bugs
> of severity 'important' when the bugs are not even associated with a
> release goal[0].
> 
>     [2] I am thinking about automating the gory details
>     [0] http://release.debian.org/lenny/goals.txt
> 
> Wouldn't the release team be pissed if the perl5.10 transition is done
> without them be aware if it?

Just inform them. Doing so by ccing debian-release@lists.debian.org.

IMO the NMU campaign is fully justified. An NMU campaign preparing the
python transition has been done, I see no reason to not do the same for
perl.

Can someone of the release team acknowledge this? The transition to
perl5.10 is in preparation since quite some time and the package has
been maturing in experimental. IMO the "release goal" status can be
granted to allow for easy NMU of the 109 package that remain to be
updated.

See http://wiki.debian.org/Perl5.10Transition for more info. There's a
link to the usertagged bugs.

Cheers,
-- 
Raphaël Hertzog

Le best-seller français mis à jour pour Debian Etch :
http://www.ouaza.com/livre/admin-debian/




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Marc 'HE' Brockschmidt <he@ftwca.de>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #50 received at 465783@bugs.debian.org (full text, mbox):

From: Marc 'HE' Brockschmidt <he@ftwca.de>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 465783@bugs.debian.org, debian-perl@lists.debian.org, debian-release@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Tue, 25 Mar 2008 16:38:06 +0100
[Message part 1 (text/plain, inline)]
Raphael Hertzog <hertzog@debian.org> writes:
> On Tue, 25 Mar 2008, Damyan Ivanov wrote:
>> Wouldn't the release team be pissed if the perl5.10 transition is done
>> without them be aware if it?

*cough* I was well aware of the transition and have kept it in mind for
most of the recent planning. It needs a bit of coordination with other
transitions, as both the python and the OCaml 3.10.2 transition will
also need some binNMUs, putting additional load on the buildds. I tried
pinging Brendan in IRC a few times in the past two weeks to talk about
the issue, but never was around at the right time to actually speak with
him. I guess doing it by mail is more sane, anyway :)

> IMO the NMU campaign is fully justified. An NMU campaign preparing the
> python transition has been done, I see no reason to not do the same for
> perl.

Yes.

> Can someone of the release team acknowledge this? The transition to
> perl5.10 is in preparation since quite some time and the package has
> been maturing in experimental. IMO the "release goal" status can be
> granted to allow for easy NMU of the 109 package that remain to be
> updated.

Well, the release goal list is frozen by now and I wouldn't like to make
exceptions. On the other hand, I believe that having Perl 5.10 in lenny
is *critical* [1]. Uploading the new version unstable will automatically
make all of the transition bugs rc anyway, so please go ahead, happy
NMUing.

Marc

Footnotes: 
[1]  Oh, how much I want all the niceties copied from Perl6...
-- 
BOFH #359:
YOU HAVE AN I/O ERROR -> Incompetent Operator error
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Gunnar Wolf <gwolf@gwolf.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #55 received at 465783@bugs.debian.org (full text, mbox):

From: Gunnar Wolf <gwolf@gwolf.org>
To: Marc 'HE' Brockschmidt <he@ftwca.de>
Cc: Raphael Hertzog <hertzog@debian.org>, 465783@bugs.debian.org, debian-perl@lists.debian.org, debian-release@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Tue, 25 Mar 2008 10:04:57 -0600
Marc 'HE' Brockschmidt dijo [Tue, Mar 25, 2008 at 04:38:06PM +0100]:
> >> Wouldn't the release team be pissed if the perl5.10 transition is done
> >> without them be aware if it?
> 
> *cough* I was well aware of the transition and have kept it in mind for
> most of the recent planning. It needs a bit of coordination with other
> transitions, as both the python and the OCaml 3.10.2 transition will
> also need some binNMUs, putting additional load on the buildds. I tried
> pinging Brendan in IRC a few times in the past two weeks to talk about
> the issue, but never was around at the right time to actually speak with
> him. I guess doing it by mail is more sane, anyway :)

Most of the packages will be anyway arch:all, so they will not IMHO
put too much of a burden on buildds.

Greetings,

-- 
Gunnar Wolf - gwolf@gwolf.org - (+52-55)5623-0154 / 1451-2244
PGP key 1024D/8BB527AF 2001-10-23
Fingerprint: 0C79 D2D1 2C4E 9CE4 5973  F800 D80E F35A 8BB5 27AF




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Marc 'HE' Brockschmidt <marc@marcbrockschmidt.de>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #60 received at 465783@bugs.debian.org (full text, mbox):

From: Marc 'HE' Brockschmidt <marc@marcbrockschmidt.de>
To: Gunnar Wolf <gwolf@gwolf.org>
Cc: 465783@bugs.debian.org, debian-perl@lists.debian.org, debian-release@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Tue, 25 Mar 2008 18:37:11 +0100
[Message part 1 (text/plain, inline)]
Gunnar Wolf <gwolf@gwolf.org> writes:
> Marc 'HE' Brockschmidt dijo [Tue, Mar 25, 2008 at 04:38:06PM +0100]:
>>>> Wouldn't the release team be pissed if the perl5.10 transition is done
>>>> without them be aware if it?
>> *cough* I was well aware of the transition and have kept it in mind for
>> most of the recent planning. It needs a bit of coordination with other
>> transitions, as both the python and the OCaml 3.10.2 transition will
>> also need some binNMUs, putting additional load on the buildds. I tried
>> pinging Brendan in IRC a few times in the past two weeks to talk about
>> the issue, but never was around at the right time to actually speak with
>> him. I guess doing it by mail is more sane, anyway :)
> Most of the packages will be anyway arch:all, so they will not IMHO
> put too much of a burden on buildds.

http://ftp-master.debian.org/~he/perl-NMUs is a list of packages
depending on '(perlapi-5.8|libperl5.8)'. We will need to schedule about
~295 binNMUs for perl5.10, for such small packages such as abiword,
postgres-* and most of our mail servers. This will put *massive* load on
the build machines.

Marc
-- 
BOFH #272:
Netscape has crashed
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #65 received at 465783@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: debian-release@lists.debian.org
Cc: 465783@bugs.debian.org, 458144@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Tue, 25 Mar 2008 20:14:55 +0200
On Tue, Mar 25, 2008 at 06:37:11PM +0100, Marc 'HE' Brockschmidt wrote:

> http://ftp-master.debian.org/~he/perl-NMUs is a list of packages
> depending on '(perlapi-5.8|libperl5.8)'. We will need to schedule about
> ~295 binNMUs for perl5.10, for such small packages such as abiword,
> postgres-* and most of our mail servers. This will put *massive* load on
> the build machines.

Hi,

repeating notes from along the way to make sure you're aware of these
issues. They are collected at <http://wiki.debian.org/Perl5.10Transition>.

- there are five more packages needing a binNMU, they are missing ${perl:Depends}
  http://lintian.debian.org/reports/tags/missing-dependency-on-perlapi.html
  Bugs have been filed, and I believe lasso was fixed today.

- the packages needing binNMUs depend on each other for building. I cooked 
  up a rebuild order for the binNMUs back in January, see
  http://lists.debian.org/debian-perl/2008/01/msg00218.html

- it would be great if the build dependency loop with libxml-parser-perl 
  (#458144, Cc'd) could be fixed first. I think it's by far the most 
  significant problem for the binNMUs.

- I don't really know how the perl on the buildds is going to be updated, but
  manual intervention may be required to favour debconf-english over
  debconf-i18n so as to keep the Essential:yes packages installed. See
  http://lists.debian.org/debian-perl/2008/01/msg00220.html

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Marc 'HE' Brockschmidt <he@ftwca.de>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #70 received at 465783@bugs.debian.org (full text, mbox):

From: Marc 'HE' Brockschmidt <he@ftwca.de>
To: debian-release@lists.debian.org
Cc: 465783@bugs.debian.org, 458144@bugs.debian.org, debian-perl@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Wed, 26 Mar 2008 00:04:50 +0100
[Message part 1 (text/plain, inline)]
Niko Tyni <ntyni@debian.org> writes:
> On Tue, Mar 25, 2008 at 06:37:11PM +0100, Marc 'HE' Brockschmidt wrote:
>> http://ftp-master.debian.org/~he/perl-NMUs is a list of packages
>> depending on '(perlapi-5.8|libperl5.8)'. We will need to schedule about
>> ~295 binNMUs for perl5.10, for such small packages such as abiword,
>> postgres-* and most of our mail servers. This will put *massive* load on
>> the build machines.
> repeating notes from along the way to make sure you're aware of these
> issues. They are collected at <http://wiki.debian.org/Perl5.10Transition>.

Thanks, but I already use the wiki page as starting point (noone can
expect me to actually remember the BTS URIs for the usertagged reports,
right?)

The problem right now is that the situation wrt testing migration isn't
too rosy anyway at the moment, seeing how we are blocked by ghc6,
openexr/kdelibs, suitespare/openoffice.org (which is now in turn stuck
ehin kdelibs) and some other transitions. The moment perl5.10 has been
uploaded to unstable, we will need to basically freeze unstable for a
few days to get it through to testing without entangling it with other
transitions.

Brendan, have you already planned a perl upload to unstable?

> - it would be great if the build dependency loop with libxml-parser-perl 
>   (#458144, Cc'd) could be fixed first. I think it's by far the most 
>   significant problem for the binNMUs.

Yes. Ardo, could you update libxml-parser-perl with the workaround
proposed in <47C22AC9.1050300@ardolabs.com>?

Marc
-- 
Fachbegriffe der Informatik - Einfach erklärt
185: LaTeX
       Eine spülmaschinenfeste Seitenbeschreibungssprache. (Cornell Binder)
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #75 received at 465783@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 465783@bugs.debian.org
Cc: debian-release@lists.debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#465783: perl 5.10 transition, NMUs and release goals
Date: Mon, 31 Mar 2008 00:15:54 +0300
On Wed, Mar 26, 2008 at 12:04:50AM +0100, Marc 'HE' Brockschmidt wrote:

> The problem right now is that the situation wrt testing migration isn't
> too rosy anyway at the moment, seeing how we are blocked by ghc6,
> openexr/kdelibs, suitespare/openoffice.org (which is now in turn stuck
> ehin kdelibs) and some other transitions. The moment perl5.10 has been
> uploaded to unstable, we will need to basically freeze unstable for a
> few days to get it through to testing without entangling it with other
> transitions.
> 
> Brendan, have you already planned a perl upload to unstable?

With my brand new perl comaintainer hat on, I'd like to fix a date for
this. I just uploaded 5.10.0-7 to experimental fixing the known remaining
problems with libmodule-corelist-perl, and if there aren't any surprises
that should be ready for unstable.

It would be good to get most (if not all) of the remaining 30 or so
arch:any FTBFS bugs fixed before the upload. Just about all of them have
patches filed, so with one or two people (I can be one :) NMU'ing them,
I suppose a week or so would be enough.

Marc, please let us know when the release team would like the upload
to happen.

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Brendan O'Dea <bod@debian.org>:
Bug#465783; Package perl. Full text and rfc822 format available.

Acknowledgement sent to Marc 'HE' Brockschmidt <he@ftwca.de>:
Extra info received and forwarded to list. Copy sent to Brendan O'Dea <bod@debian.org>. Full text and rfc822 format available.

Message #80 received at 465783@bugs.debian.org (full text, mbox):

From: Marc 'HE' Brockschmidt <he@ftwca.de>
To: 465783@bugs.debian.org
Cc: debian-release@lists.debian.org, debian-perl@lists.debian.org
Subject: Re: Bug#465783: perl 5.10 transition, NMUs and release goals
Date: Mon, 31 Mar 2008 00:02:56 +0200
[Message part 1 (text/plain, inline)]
Niko Tyni <ntyni@debian.org> writes:
> It would be good to get most (if not all) of the remaining 30 or so
> arch:any FTBFS bugs fixed before the upload. Just about all of them have
> patches filed, so with one or two people (I can be one :) NMU'ing them,
> I suppose a week or so would be enough.

If it shouldn't be done by then, I will try to help next weekend, as a
BSP was scheduled anyway.

> Marc, please let us know when the release team would like the upload
> to happen.

It's a bit complicated right now. We have a major problem around
openexr/kdelibs, which stands in the way of almost any transition,
including the suitesparse/OO.org bits, which have been waiting for quite
a long time. 
After those have been resolved (hopefully in the next few days), we
planned to do switch the python default to python2.5, which I expect to
need another week until it's done. After that, the way is free for
Perl5.10. OTOH, uploading before python2.5 is done will make everything
much more complex, so if you don't want to unleash the wrath of the
release team, you better ask before doing the upload :-)

All in all, I would expect that we will need at least 10 days (though a
bit over two weeks sounds more realistic) before the way is clear for
Perl5.10.

Marc
-- 
BOFH #212:
Of course it doesn't work. We've performed a software upgrade.
[Message part 2 (application/pgp-signature, inline)]

Reply sent to Marc 'HE' Brockschmidt <he@ftwca.de>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Niko Tyni <ntyni@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #85 received at 465783-done@bugs.debian.org (full text, mbox):

From: Marc 'HE' Brockschmidt <he@ftwca.de>
To: 465783-done@bugs.debian.org
Cc: debian-perl@lists.debian.org
Subject: Re: perl 5.10 transition, NMUs and release goals
Date: Sun, 06 Apr 2008 12:47:43 +0200
[Message part 1 (text/plain, inline)]
Marc 'HE' Brockschmidt <he@ftwca.de> writes:
> Raphael Hertzog <hertzog@debian.org> writes:
>> Can someone of the release team acknowledge this? The transition to
>> perl5.10 is in preparation since quite some time and the package has
>> been maturing in experimental. IMO the "release goal" status can be
>> granted to allow for easy NMU of the 109 package that remain to be
>> updated.
>
> Well, the release goal list is frozen by now and I wouldn't like to make
> exceptions. On the other hand, I believe that having Perl 5.10 in lenny
> is *critical* [1]. Uploading the new version unstable will automatically
> make all of the transition bugs rc anyway, so please go ahead, happy
> NMUing.

As a status update: I've just NMUed the last one of the
perl-5.10-ftbfs-rmdir bugs. This weekend's BSP made mass-uploads
easy. Anyway, only two dozens of packages are left to fix up for 5.10,
most of which have already patches. As these include more complex fixes,
I would love to wait with those until perl5.10 is uploaded to unstable,
so that fixes can be tested more easily.

Anyway, the actual reason for #465783 has been fixed, so I'm closing the
bug again.

In other news, I think that April 16th might not work out. We've sorted
out openexr/kdelibs now, but perl5.10 is still in the queue behind
python2.5 and the infamous suitesparse/OO.org transition.

Marc
-- 
BOFH #172:
pseudo-user on a pseudo-terminal
[Message part 2 (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 05 May 2008 07:41:04 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 11:47:53 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.